# This config lists the jobs that will be run on omnibus-gitlab project in
# dev.gitlab.org.

#############
# Templates #
#############

.except-auto-deploy-tag: &except-auto-deploy-tag
  except:
    variables:
      # Format of the auto-deploy tag for auto-deploy builds.
      # https://gitlab.com/gitlab-org/release/docs/blob/master/general/deploy/auto-deploy.md#auto-deploy-tagging
      - $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+\+[^ ]{7,}\.[^ ]{7,}$/

.dev-tag-only: &dev-tag-only
  only:
    - tags@gitlab/omnibus-gitlab
  <<: *except-auto-deploy-tag

.dev-except-branches: &dev-except-branches
   only:
    - tags@gitlab/omnibus-gitlab
    - schedules@gitlab/omnibus-gitlab
    - triggers@gitlab/omnibus-gitlab

.package-artifacts: &package-artifacts
  when: always
  expire_in: 1 day
  paths:
    - pkg/

.package-artifacts-release: &package-artifacts-release
  <<: *package-artifacts
  expire_in: 7 days

.branch-cache: &branch-cache
  key: "${CI_JOB_NAME}-branch-${BUILDER_IMAGE_REVISION}"
  paths:
  - cache
  - gems
  - assets_cache
  - .yarn-cache

.tag-cache: &tag-cache
  key: "${CI_JOB_NAME}-${BUILDER_IMAGE_REVISION}"
  <<: *branch-cache

.branch_template: &branch_build
  stage: package-and-image
  script:
    - echo -e "[default]\naws_access_key_id = $AWS_ACCESS_KEY_ID \naws_secret_access_key = $AWS_SECRET_ACCESS_KEY" > ~/.aws/config
    # GPG key for package signing
    - AWS_ACCESS_KEY_ID="$SECRET_AWS_ACCESS_KEY_ID" AWS_SECRET_ACCESS_KEY="$SECRET_AWS_SECRET_ACCESS_KEY" aws s3 cp s3://omnibus-sig/package.sig.key .
    - gpg --batch --no-tty --allow-secret-key-import --import package.sig.key
    - bundle exec rake cache:populate
    - bundle exec rake cache:restore
    - bundle exec rake build:project build:package:sync
    - bundle exec rake cache:bundle
    - bundle exec rspec --color --format RspecJunitFormatter --out junit_ci_rspec.xml --format documentation ci_build_specs
  tags:
  - docker-builder
  only:
    - branches@gitlab/omnibus-gitlab
  artifacts:
    <<: *package-artifacts
    reports:
      junit: junit_ci_rspec.xml
  dependencies:
    - fetch-assets
  cache: *branch-cache
  retry: 1

.rpi_branch_template: &rpi_branch_build
  <<: *branch_build
  stage: slow_jobs
  variables:
    NO_SOURCEMAPS: "true"
  tags:
  - docker-rpi-builder
  except:
    refs:
      - /.*-stable-ee/
    variables:
      - $ee == "true"
      - $NIGHTLY == "true"
  artifacts: *package-artifacts
  retry: 1

.tag_template: &tag_build
  stage: package-and-image
  script:
    # Always compile assets for auto-deploy builds,
    # this is done for auto-deploy builds
    # so that we do not have to wait for the compile assets job
    # in the gitlab-ee pipeline.
    - |
      if echo $CI_COMMIT_TAG | grep -P -q "$AUTO_DEPLOY_TAG_REGEX"; then
        echo "Setting COMPILE_ASSETS env variable for auto-deploy"
        export COMPILE_ASSETS='true';
      fi
    - echo -e "[default]\naws_access_key_id = $AWS_ACCESS_KEY_ID \naws_secret_access_key = $AWS_SECRET_ACCESS_KEY" > ~/.aws/config
    # GPG key for package signing
    - AWS_ACCESS_KEY_ID="$SECRET_AWS_ACCESS_KEY_ID" AWS_SECRET_ACCESS_KEY="$SECRET_AWS_SECRET_ACCESS_KEY" aws s3 cp s3://omnibus-sig/package.sig.key .
    - gpg --batch --no-tty --allow-secret-key-import --import package.sig.key
    - bundle exec rake cache:populate
    - bundle exec rake cache:restore
    - bundle exec rake release:package
    - bundle exec rake cache:bundle
  tags:
  - docker-builder
  <<: *dev-tag-only
  artifacts: *package-artifacts-release
  dependencies:
    - fetch-assets
  cache: *tag-cache
  retry: 1

.rpi_tag_template: &rpi_tag_build
  <<: *tag_build
  stage: slow_jobs
  variables:
    NO_SOURCEMAPS: "true"
  tags:
  - docker-rpi-builder
  except:
    refs:
      - /.*ee\.\d/
    variables:
      - $ee == "true"
      # Format of the auto-deploy tag for auto-deploy builds.
      # https://gitlab.com/gitlab-org/release/docs/blob/master/general/deploy/auto-deploy.md#auto-deploy-tagging
      - $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+\+[^ ]{7,}\.[^ ]{7,}$/

### This stage is used for uploading packages
### 1. To a staging package repository
### 2. Always ran on dev.gitlab.org
.staging_upload_template: &staging_upload
  stage: staging_upload
  image: "dev.gitlab.org:5005/gitlab/gitlab-build-images:omnibus-gitlab-xenial"
  script:
    - bundle exec rake repository:upload:staging[$STAGING_REPO]
  artifacts: *package-artifacts-release
  cache: *tag-cache
  retry: 2
  tags:
  - promotion
  <<: *dev-tag-only

### This stage is ran only on tag:
### 1. It is a manual action
### 2. It will upload the package to public, user facing repositories
### 3. Only ran on dev.gitlab.org
.production_release_template: &production_release
  stage: package-and-image-release
  image: "dev.gitlab.org:5005/gitlab/gitlab-build-images:omnibus-gitlab-xenial"
  script:
    - bundle exec rake repository:upload:production
  retry: 2
  <<: *dev-tag-only
  when: manual
  cache: *tag-cache
  tags:
  - promotion

.raspbian_release_template: &raspbian_release
  <<: *production_release
  variables:
    RASPBERRY_REPO: "raspberry-pi2"
  stage: raspbian-release
  retry: 2
  <<: *dev-tag-only
  except:
    refs:
      - /.*ee\.\d/
    variables:
      - $ee == "true"
      # Format of the auto-deploy tag for auto-deploy builds.
      # https://gitlab.com/gitlab-org/release/docs/blob/master/general/deploy/auto-deploy.md#auto-deploy-tagging
      - $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+\+[^ ]{7,}\.[^ ]{7,}$/

.aws_marketplace_release: &aws_marketplace_release
  image: "${BUILDER_IMAGE_REGISTRY}/ruby_docker:${BUILDER_IMAGE_REVISION}"
  stage: aws-marketplace-release
  when: manual
  script:
    - curl --request POST
      --form "token=$AWS_RELEASE_TRIGGER_TOKEN"
      --form ref=master
      --form "variables[GITLAB_VERSION]=$CI_COMMIT_TAG"
      --form "variables[AWS_LISTING_NAME]=$AWS_LISTING_NAME"
      https://dev.gitlab.org/api/v4/projects/1035/trigger/pipeline
  only:
    refs:
      - /.*ee\.\d/@gitlab/omnibus-gitlab
  except:
    variables:
      - $CI_COMMIT_TAG =~ /^.*\+rc.*/
      # Format of the auto-deploy tag for auto-deploy builds.
      # https://gitlab.com/gitlab-org/release/docs/blob/master/general/deploy/auto-deploy.md#auto-deploy-tagging
      - $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+\+[^ ]{7,}\.[^ ]{7,}$/
  dependencies:
    - AWS

###########################
#     Branch pipeline     #
###########################

# fetch-assets job from .gitlab-ci.yml file runs here

# We build package for deploying to GitLab.com first
Ubuntu-16.04-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_16.04:${BUILDER_IMAGE_REVISION}"
  stage: gitlab_com:package
  extends: .branch_template
Ubuntu-18.04-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_18.04:${BUILDER_IMAGE_REVISION}"
  stage: gitlab_com:package
  extends: .branch_template

Debian-8-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/debian_8:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build
Debian-9-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/debian_9:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build
Debian-10-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/debian_10:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build
CentOS-6-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/centos_6:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build
CentOS-7-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/centos_7:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build
OpenSUSE-15.0-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/opensuse_15.0:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build
SLES-12-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/sles_12sp2:${BUILDER_IMAGE_REVISION}"
  <<: *branch_build

Docker-branch:
  extends: .docker_job
  stage: package-and-image
  script:
  - bundle exec rake docker:build:image
  - bundle exec rake docker:push:staging
  - bundle exec rake docker:push:nightly
  only:
    - branches@gitlab/omnibus-gitlab
  tags:
  - docker-builder
  cache: *branch-cache
  dependencies: []
  retry: 1

Docker-branch-measure-memory:
  extends: .measure_memory_script_artifacts
  stage: metrics
  only:
    - schedules@gitlab/omnibus-gitlab
  tags:
  - docker-builder
  cache: *branch-cache
  dependencies: []

QA-Master:
  extends: .docker_job
  stage: package-and-image
  variables:
    QA_SCREENSHOTS_DIR: $CI_PROJECT_DIR/screenshots
  script:
    - bundle exec rake qa:build
    - bundle exec rake qa:push:nightly
  artifacts:
    when: on_failure
    expire_in: 7d
    paths:
    - screenshots/
  allow_failure: true
  only:
    - branches@gitlab/omnibus-gitlab
  tags:
  - docker-builder
  cache: *branch-cache
  dependencies:
    - Ubuntu-16.04-branch
  retry: 1

Raspberry-Pi-2-Stretch-branch:
  image: "${BUILDER_IMAGE_REGISTRY}/rpi_9:${BUILDER_IMAGE_REVISION}"
  <<: *rpi_branch_build

# This job runs only on nightly EE builds
HA-Validate-Nightly:
  stage: slow_jobs
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_16.04:${BUILDER_IMAGE_REVISION}"
  script:
    - '[[ -n "${NIGHTLY}" ]] || exit 0'
    - bundle exec rake qa:ha:nightly
  only:
    refs:
      - schedules@gitlab/omnibus-gitlab
    variables:
      - $ee == "true"
  cache: *branch-cache
  dependencies: []

############################
#     Release pipeline     #
############################

# fetch-assets job from .gitlab-ci.yml file runs here

# We build package for deploying to GitLab.com first
Ubuntu-16.04:
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_16.04:${BUILDER_IMAGE_REVISION}"
  stage: gitlab_com:package
  extends: .tag_template
  # Also build for auto-deploy tags
  except:
    variables: []

Ubuntu-18.04:
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_18.04:${BUILDER_IMAGE_REVISION}"
  stage: gitlab_com:package
  extends: .tag_template
  # Also build for auto-deploy tags
  except:
    variables: []

## Build the docker image for QA
## This is necessary for the deployment
## pipeline so it must happen before
## the upload and deploy stage for GitLab.com
Docker-QA:
  extends: .docker_job
  stage: gitlab_com:package
  script:
    - bundle exec rake qa:build qa:push:staging
  <<: *dev-tag-only
  cache: *tag-cache
  tags:
  - docker-builder
  dependencies: []
  retry: 1
  # Also build for auto-deploy tags
  except:
    variables: []

###########################################################
## Upload and deploy to staging or preprod for GitLab.com
## * Regular tagged releases are deployed to staging
## * Auto-deploy tagged releases are deployed to
##   $AUTO_DEPLOY_ENVIRONMENT, set in CI vars
## * Regular patch releases, RCs and tags that are
##   not auto-deploys are deployed to
##   $PATCH_DEPLOY_ENVIRONMENT, set in CI vars
##
##  Ubuntu 16.04: used for all omnibus installation
##  Ubuntu 18.04: used on some non-omnibus infrastructure, we
##                will eventually need to trigger deployments
##                after this package is built

Ubuntu-16.04-upload-deploy:
  stage: gitlab_com:upload_deploy
  extends: .staging_upload_template
  dependencies:
    - Ubuntu-16.04
    - Ubuntu-16.04-branch
  script:
    - |
      if echo $CI_COMMIT_TAG | grep -P -q "$AUTO_DEPLOY_TAG_REGEX"; then
        export DEPLOYER_ENVIRONMENT="$AUTO_DEPLOY_ENVIRONMENT";
      else
        export DEPLOYER_ENVIRONMENT="$PATCH_DEPLOY_ENVIRONMENT";
      fi
    - bundle exec rake repository:upload:staging[$STAGING_REPO]
    - if [ -n "$DEPLOYER_TRIGGER_TOKEN" ]; then bundle exec rake gitlab_com:deployer; fi
  <<: *dev-except-branches
  except:
    variables: []

Ubuntu-18.04-upload-deploy:
  stage: gitlab_com:upload_deploy
  extends: .staging_upload_template
  dependencies:
    - Ubuntu-18.04
    - Ubuntu-18.04-branch
  script:
    - |
    - bundle exec rake repository:upload:staging[$STAGING_REPO]
  <<: *dev-except-branches
  except:
    variables: []
############################################################

### Package builds
Debian-8:
  image: "${BUILDER_IMAGE_REGISTRY}/debian_8:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
Debian-9:
  image: "${BUILDER_IMAGE_REGISTRY}/debian_9:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
Debian-10:
  image: "${BUILDER_IMAGE_REGISTRY}/debian_10:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
CentOS-6:
  image: "${BUILDER_IMAGE_REGISTRY}/centos_6:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
CentOS-7:
  image: "${BUILDER_IMAGE_REGISTRY}/centos_7:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
OpenSUSE-15.0:
  image: "${BUILDER_IMAGE_REGISTRY}/opensuse_15.0:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
SLES-12:
  image: "${BUILDER_IMAGE_REGISTRY}/sles_12sp2:${BUILDER_IMAGE_REVISION}"
  <<: *tag_build
  only:
    refs:
      - /.*ee\.\d/@gitlab/omnibus-gitlab

dependency_scanning:
  image: "registry.gitlab.com/gitlab-org/gitlab-build-images:omnibus-gitlab-depscan"
  stage: scan-dependencies
  allow_failure: true
  variables:
    TERM: xterm-256color
    REPORT_PATH: ./
  before_script: []
  script:
    - manifest=pkg/ubuntu-xenial/*.version-manifest.json
    - curl -sSL https://gitlab.com/gitlab-org/security-products/gitlab-depscan/raw/master/gitlab-depscan.sh|bash -s $manifest
  <<: *dev-except-branches
  <<: *except-auto-deploy-tag
  dependencies:
    - Ubuntu-16.04
    - Ubuntu-16.04-branch
  artifacts:
    expire_in: 7 days
    when: on_failure
    paths:
      - dependency_report.txt
      - gl-dependency-scanning-report.json

Docker:
  extends: .docker_job
  stage: package-and-image
  script:
  - bundle exec rake docker:build:image
  - bundle exec rake docker:push:staging
  <<: *dev-tag-only
  tags:
  - docker-builder
  cache: *tag-cache
  dependencies: []
  retry: 1

Docker-measure-memory:
  extends: .measure_memory_script_artifacts
  stage: metrics
  <<: *dev-tag-only
  when: manual
  tags:
  - docker-builder
  cache: *tag-cache
  dependencies: []

### Staging uploads
Ubuntu-18.04-staging:
  dependencies:
    - Ubuntu-18.04
    - Ubuntu-18.04-branch
  <<: *staging_upload
Debian-8-staging:
  dependencies:
    - Debian-8
    - Debian-8-branch
  <<: *staging_upload
Debian-9-staging:
  dependencies:
    - Debian-9
    - Debian-9-branch
  <<: *staging_upload
Debian-10-staging:
  dependencies:
    - Debian-10
    - Debian-10-branch
  <<: *staging_upload
CentOS-6-staging:
  dependencies:
    - CentOS-6
    - CentOS-6-branch
  <<: *staging_upload
CentOS-7-staging:
  dependencies:
    - CentOS-7
    - CentOS-7-branch
  <<: *staging_upload
OpenSUSE-15.0-staging:
  dependencies:
    - OpenSUSE-15.0
    - OpenSUSE-15.0-branch
  <<: *staging_upload
SLES-12-staging:
  dependencies:
    - SLES-12
    - SLES-12-branch
  only:
    refs:
      - branches@gitlab/omnibus-gitlab
  <<: *staging_upload

### Package releases
Ubuntu-16.04-release:
  dependencies:
    - Ubuntu-16.04
  <<: *production_release
Ubuntu-18.04-release:
  dependencies:
    - Ubuntu-18.04
  <<: *production_release
Debian-8-release:
  dependencies:
    - Debian-8
  <<: *production_release
Debian-9-release:
  dependencies:
    - Debian-9
  <<: *production_release
Debian-10-release:
  dependencies:
    - Debian-10
  <<: *production_release
CentOS-6-release:
  dependencies:
    - CentOS-6
  <<: *production_release
CentOS-7-release:
  dependencies:
    - CentOS-7
  <<: *production_release
OpenSUSE-15.0-release:
  dependencies:
    - OpenSUSE-15.0
  <<: *production_release
SLES-12-release:
  dependencies:
    - SLES-12
  only:
    refs:
      - /.*ee\.\d/@gitlab/omnibus-gitlab
  <<: *production_release

Docker-Release:
  extends: .docker_job
  stage: package-and-image-release
  script:
    - bundle exec rake release:docker
  <<: *dev-tag-only
  cache: *tag-cache
  dependencies: []
  when: manual

AWS:
  stage: package-and-image-release
  image: "${BUILDER_IMAGE_REGISTRY}/debian_packer:${BUILDER_IMAGE_REVISION}"
  script:
  # aws-sdk gem gives priority to environment variables over config file. So, using correct values for those variables.
  - export AWS_ACCESS_KEY_ID=$AWS_AMI_ACCESS_KEY_ID
  - export AWS_SECRET_ACCESS_KEY=$AWS_AMI_SECRET_ACCESS_KEY
  - bundle exec rake aws:process
  tags:
  - docker-builder
  when: manual
  <<: *dev-tag-only
  cache: *tag-cache
  dependencies: []
  retry: 1

AWS-Ultimate:
  stage: package-and-image-release
  image: "${BUILDER_IMAGE_REGISTRY}/debian_packer:${BUILDER_IMAGE_REVISION}"
  variables:
    EE_ULTIMATE_AMI: "true"
  script:
  # aws-sdk gem gives priority to environment variables over config file. So, using correct values for those variables.
  - export AWS_ACCESS_KEY_ID=$AWS_AMI_ACCESS_KEY_ID
  - export AWS_SECRET_ACCESS_KEY=$AWS_AMI_SECRET_ACCESS_KEY
  - bundle exec rake aws:process
  tags:
  - docker-builder
  when: manual
  only:
    refs:
      - /.*ee\.\d/@gitlab/omnibus-gitlab
  except:
    variables:
      # Format of the auto-deploy tag for auto-deploy builds.
      # https://gitlab.com/gitlab-org/release/docs/blob/master/general/deploy/auto-deploy.md#auto-deploy-tagging
      - $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+\+[^ ]{7,}\.[^ ]{7,}$/
  cache: *tag-cache
  dependencies: []
  retry: 1

QA-Tag:
  extends: .docker_job
  stage: package-and-image-release
  variables:
    QA_SCREENSHOTS_DIR: $CI_PROJECT_DIR/screenshots
  script:
    - bundle exec rake release:qa
  artifacts:
    when: on_failure
    expire_in: 7d
    paths:
    - screenshots/
  allow_failure: true
  <<: *dev-tag-only
  tags:
  - docker-builder
  cache: *tag-cache
  dependencies:
    - Ubuntu-16.04
  retry: 1
  when: manual

upgrade:
  stage: metrics
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_16.04:${BUILDER_IMAGE_REVISION}"
  script:
    - echo $GCP_SERVICE_ACCOUNT > service_account.json
    - bundle exec rake metrics:upgrade_package
  allow_failure: true
  when: manual
  <<: *dev-tag-only
  tags:
  - docker-builder
  cache: *tag-cache
  dependencies: []

license-upload:
  stage: metrics
  image: "${BUILDER_IMAGE_REGISTRY}/ubuntu_18.04:${BUILDER_IMAGE_REVISION}"
  script:
    - bundle exec rake license:upload
  allow_failure: true
  when: manual
  <<: *dev-tag-only
  tags:
  - docker-builder
  cache: *tag-cache
  dependencies:
    - Ubuntu-18.04

HA-Validate-Tagged:
  stage: slow_jobs
  image: "dev.gitlab.org:5005/cookbooks/gitlab-omnibus-builder/ubuntu_16.04:${BUILDER_IMAGE_REVISION}"
  script:
    - bundle exec rake qa:ha:tag
  only:
    refs:
      - /.*ee\.\d/@gitlab/omnibus-gitlab
  cache: *tag-cache
  dependencies: []
  allow_failure: true

Raspberry-Pi-2-Stretch:
  image: "${BUILDER_IMAGE_REGISTRY}/rpi_9:${BUILDER_IMAGE_REVISION}"
  <<: *rpi_tag_build

Raspberry-Pi-2-Stretch-release:
  dependencies:
    - Raspberry-Pi-2-Stretch
  <<: *raspbian_release

AWS-CE-Release:
  variables:
    AWS_LISTING_NAME: "GitLab Community Edition"
  extends: .aws_marketplace_release
  only:
    refs:
      - /.*ce\.\d/@gitlab/omnibus-gitlab

AWS-EE-Ultimate-Release:
  variables:
    AWS_LISTING_NAME: "GitLab Ultimate - 5 User Pack"
  extends: .aws_marketplace_release
